@echo off

chdir /D %~dp0

set KEY_NAME="HKEY_LOCAL_MACHINE\SYSTEM\CONTROLSET001\CONTROL\NLS\LANGUAGE"
set VALUE_NAME=Installlanguage

for /F "tokens=3 delims= " %%G in (
  'REG QUERY %KEY_NAME% /v %VALUE_NAME%') do (
    set INSTALL_LANG=%%G
)

set PRODUCT=AquaSoft DiaShow 7 Ultimate
set PRODUCT_ID={2FAA2415-618E-4EC0-8253-3CDA076C84D6}
set PRODUCT_CODE=5142AAF2E8160CE42835C3AD70C6486D
set UPGRADE_CODE=E464A8504F8847342A560FF6DD62FEE2
set INSTALLER_PATH=%WINDIR%\Installer\%PRODUCT_ID%

reg Query "HKLM\Hardware\Description\System\CentralProcessor\0" | find /i "x86" > NUL && set OS=32BIT || set OS=64BIT

if %OS%==32BIT (
  set SOFTWARE_KEY=SOFTWARE 
) else (
  set SOFTWARE_KEY=SOFTWARE\Wow6432Node
)

set ID_CACHE=%SOFTWARE_KEY%\MimarSinan\InstallAware\Ident.Cache
set KEY_NAME="HKEY_LOCAL_MACHINE\%ID_CACHE%\%PRODUCT_ID%"
set VALUE_NAME=""

for /F "usebackq skip=2 tokens=1,2*" %%A in (
 `REG QUERY %KEY_NAME% /v %VALUE_NAME% 2^>nul`) do (
    set "ValueName=%%A"
    set "ValueType=%%B"
    set CACHE_PATH="%%C"
)

if defined CACHE_PATH (
  set CACHE_PATH=%CACHE_PATH:"=%
  echo CACHE_PATH = %CACHE_PATH%
  rd %CACHE_PATH% /s /q
  if not exist %CACHE_PATH%\nul regtool -d -r3 "%ID_CACHE%\%PRODUCT_ID%\"
)

if not defined CACHE_PATH (
  if [%INSTALL_LANG%] EQU [0407] (
    echo %KEY_NAME%\%VALUE_NAME% nicht gefunden.
  ) else (
    echo %KEY_NAME%\%VALUE_NAME% not found.
  )
)

rd %INSTALLER_PATH% /s /q

rem HKEY_CLASSES_ROOT
regtool -d -r1 "Installer\Features\%PRODUCT_CODE%\"
regtool -d -r1 "Installer\Products\%PRODUCT_CODE%\"
regtool -d -r1 "Installer\UpgradeCodes\%UPGRADE_CODE%\%PRODUCT_CODE%"

rem HKEY_CURRENT_USER
regtool -d -r2 "%SOFTWARE_KEY%\Microsoft\Installer\Features\%PRODUCT_CODE%\"
regtool -d -r2 "%SOFTWARE_KEY%\Microsoft\Installer\Products\%PRODUCT_CODE%\"
regtool -d -r2 "%SOFTWARE_KEY%\Microsoft\Installer\UpgradeCodes\%UPGRADE_CODE%\%PRODUCT_CODE%"
regtool -d -r2 "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\%PRODUCT_ID%\"

rem HKEY_LOCAL_MACHINE
regtool -d -r3 "%SOFTWARE_KEY%\Classes\Installer\Features\%PRODUCT_CODE%\"
regtool -d -r3 "%SOFTWARE_KEY%\Classes\Installer\Products\%PRODUCT_CODE%\"
regtool -d -r3 "%SOFTWARE_KEY%\Classes\Installer\UpgradeCodes\%UPGRADE_CODE%\%PRODUCT_CODE%"
regtool -d -r3 "%SOFTWARE_KEY%\Microsoft\Windows\CurrentVersion\App Management\ARPCache\%PRODUCT%\"
regtool -d -r3 "%SOFTWARE_KEY%\Microsoft\Windows\CurrentVersion\App Management\ARPCache\%PRODUCT_ID%\"
regtool -d -r3 "%SOFTWARE_KEY%\Microsoft\Windows\CurrentVersion\Installer\Folders\%INSTALLER_PATH%\"
regtool -d -r3 "%SOFTWARE_KEY%\Microsoft\Windows\CurrentVersion\Installer\UpgradeCodes\%UPGRADE_CODE%\%PRODUCT_CODE%"
regtool -d -r3 "%SOFTWARE_KEY%\Microsoft\Windows\CurrentVersion\Installer\UserData\S-1-5-18\Products\%PRODUCT_CODE%\"
regtool -d -r3 "%SOFTWARE_KEY%\Microsoft\Windows\CurrentVersion\Installer\UserData\S-1-5-21-2353559002-657323700-643270958-1005\Products\%PRODUCT_CODE%\"
regtool -d -r3 "%SOFTWARE_KEY%\Microsoft\Windows\CurrentVersion\Uninstall\%PRODUCT_ID%\"
regtool -d -r3 "%SOFTWARE_KEY%\Microsoft\Windows\CurrentVersion\Uninstall\%PRODUCT%\"
regtool -d -r3 "%SOFTWARE_KEY%\MimarSinan\InstallAware\Ident.Cache\%PRODUCT_ID%\"

IF %ERRORLEVEL% == 0 goto ende

echo.
echo.
echo.

if [%INSTALL_LANG%] EQU [0407] (
  echo Fehler, regtool.exe nicht gefunden. Bitte entpacken Sie das komplette ZIP-Archiv vor dem Ausfuehren der Datei.
) else (
  echo Error, regtool.exe not found. Please unzip the complete ZIP archive before executing the file.
)

echo.
echo.
echo.

pause

:ende